world.lighttype(1,2)
world.lightcomponent(1,1)
world.lightambient(1,color.new(255,255,255))
world.lightposition(1,0,0,-150)
world.lightenabled(1,true)
world.lightattenuation(1,0,0,0.0000005)
world.lights(true)
world.ambient(color.new(0,0,0))
world.specular(4.04)
world.update()
os.cpu(333)

controls.homepopup(0)

_3axis = false -- false o true
maxbars = 5 -- 5 o 10
maxreds = 2 -- 2 o 4
banposz = -198 -- -198 o -220
balls = 1 -- 1 o 2 bolas
plyrs = 1 -- 1 o 2 jugadores
totliv = 5 -- 5 o 10 vidas para cada jugador
--[[
	modo normal, 1 jugador, 1 bola, 2 o 3 ejes (score)
		jugador 1: 5 vidas
	modo extreme, 1 jugador, 2 bolas, 3 ejes (score)
		jugador 1: 10 vidas
	modo 2 jugadores, 2 bolas (1 c/u), 3 ejes (survival, quien resiste mas tiempo)
		jugador 1: 5 vidas
		jugador 2: 5 vidas
--]]

extrm = false -- modo extremo, 1 jugador, 2 bolas, slo as

dofile("animring.lua")

credits = {
	{text="Code & Graphics",title=true},
	{text="Chimecho",title=false},
	{text="",title=false},
	{text="",title=false},
	{text="Music by",title=true},
	{text="DeViaNTe",title=false},
	{text="",title=false},
	{text="",title=false},
	{text="Betatesters",title=true},
	{text="cam-maker",title=false},
	{text="Boujack",title=false},
	{text="xerpi",title=false},
	{text="Rober Galarga",title=false},
	{text="Samuelfrm",title=false},
	{text="",title=false},
	{text="",title=false},
	{text="",title=false},
	{text="",title=false},
	{text="",title=false},
	{text="",title=false},
	{text="Visit",title=true},
	{text="www.gcrew.es",title=false}
}

function creditos()
	local posyi = 300
	local fonpos = 0
	local frcta = 255
	while true do
		if soundon then if menusnd:percent() >= 99.8 then menusnd:percent(6.95) end end
		
		if posyi>-315 then fonpos = fonpos + 0.5 end
		
		if fonpos>=315 then
			fonpos = 0
		end
		
		fnd:blit(-198,fonpos-315)
		fnd:blit(198,fonpos-315)
		fnd:blit(-198,fonpos)
		fnd:blit(198,fonpos)
		
		frcta = frcta - 1
		if frcta<=220 then frcta = 220 end
		
		draw.fillrect(0,0,480,272,color.new(0,0,0,frcta))
		
		local posy = 10
		for i=1,#credits do
			local tam = credits[i].title and 25 or 22
			if credits[i].title then
				screen.print(240-screen.textwidth(credits[i].text,1.2)/2,posy+posyi,credits[i].text,1.2,color.new(255,255,0),0x0)
			else
				screen.print(240-screen.textwidth(credits[i].text,1)/2,posy+posyi,credits[i].text,1,color.new(255,255,255),0x0)
			end
			posy = posy + tam
		end
		posyi = posyi - 0.5
		if posyi<-320 then posyi = -320 break end
		screen.flip()
	end
	tmpimg = screen.toimage()
	screen.waitvblankstart(100)
	for i=255,0,-5 do
		if soundon then if menusnd:percent() >= 99.8 then menusnd:percent(6.95) end end
		image.blend(0,0,tmpimg,i)
		screen.flip()
	end
end

loader = image.load("img_res/loader.png")
loaderang = 0
loading = "Loading"

function loadcallback()
	loaderang = loaderang + 10
	loader:rotate(loaderang)
	loader:blit(20,257)
	screen.print(40,254,loading.." ",color.new(255,255,255))
	screen.print(40+screen.textwidth(loading.." "),254,loading_text.."...",color.new(200,200,255))
	screen.flip()
end

loading_text = "menu"

framesanims = {4, 11, 2, 2, 10, 3, 24, 2} -- cuantos frames por anim
loopsanims = {true, true, false, false, true, false, true, false} -- son loops?
timesanims = {100, 60, 60, 100, 95, 60, 70, 60} -- duracion entre los cuadros de las anims
animsframes = {}

for j=1,8 do -- 8 opciones
	animsframes[j] = {}
	for i=1,framesanims[j] do
		animsframes[j][i] = image.load("img_res/menu/op"..j.."/"..i..".png")
	end
end

opciones = {}
for i=1,8 do -- 8 opciones
	opciones[i] = {anim = anim.create(animsframes[i],timesanims[i]), loop = loopsanims[i]}
end

menu = animring.create(320,60,opciones)

loading_text = "intro"
introimgs = {}
for i=1,2 do
	introimgs[i] = {}
	introimgs[i].fnd = image.load("img_res/intro"..i.."/fnd.png")
	introimgs[i].hud = image.load("img_res/intro"..i.."/hud.png")
	introimgs[i].bar1 = image.load("img_res/intro"..i.."/bar1.png")
	introimgs[i].bar2 = image.load("img_res/intro"..i.."/bar2.png")
	introimgs[i].ball = image.load("img_res/intro"..i.."/ball.png")
end

do
introvars = {}
introvars[1] = {}
introvars[1].mov = 5
introvars[1].clipy = 42
introvars[1].bord1 = 39
introvars[1].bord2 = 39
introvars[1].barsize = 66
introvars[1].ballsize = 22
introvars[1].limitxi = 40
introvars[1].limitxd = 370
introvars[1].picos = 53

introvars[2] = {}
introvars[2].mov = 2
introvars[2].clipy = 39
introvars[2].bord1 = 39
introvars[2].bord2 = 39
introvars[2].barsize = 60
introvars[2].ballsize = 20
introvars[2].limitxi = 40
introvars[2].limitxd = 380
introvars[2].picos = 62

introvars[3] = {}
introvars[3].limitxi = 10
introvars[3].limitxd = 350

limitxi = 10
limitxd = 350

N = color.new(0,0,0)
negro = N
T = 0x0

loading_text = "textures"
genesis = image.load("img_res/genesis.png")
fog_a = image.load("img_res/fog_a.png")
fog_b = image.load("img_res/fog_b.png")
au = image.load("img_res/au.png")
ad = image.load("img_res/ad.png")
fnd = image.load("img_res/fnd.png")
paused = image.load("img_res/paused.png")

loading = "Loading and processing"
loading_text = "models"
fondo = model.load("obj_res/fondo.obj",1.5,color.new(0,0,0))
banner = model.load("obj_res/banner.obj",1.5,color.new(0,0,0))
bar1 = model.load("obj_res/bar1.obj",1.5,color.new(0,0,0))
bar2 = model.load("obj_res/bar2.obj",1.5,color.new(0,0,0))
ball = model.load("obj_res/ball.obj",1.5,color.new(0,0,0))
ball2 = model.load("obj_res/ball2.obj",1.5,color.new(0,0,0))
heart = model.load("obj_res/cora.obj",0.5,color.new(0,0,0))
scores_title = model.load("obj_res/scores.obj")

loading_text = "music"
menusnd = sound.load("snd_res/menu.mp3")
gamesnd = sound.load("snd_res/cool.mp3")
intro = sound.load("snd_res/shutter.mp3")
end

for i=255,0,-2 do
	loaderang = loaderang + 10
	loader:rotate(loaderang)
	image.blend(20,257,loader,i)
	screen.print(40,254,"Everything loaded",color.new(255,255,255,i))
	screen.flip()
end
loader:free()
screen.waitvblankstart(50)

function genesissplash()
	for i=0,255,5 do
		image.blend(0,0,genesis,i)
		screen.flip()
	end
	screen.waitvblankstart(200)
	for i=255,0,-5 do
		image.blend(0,0,genesis,i)
		screen.flip()
	end
	genesis:free()
end

function splash() -- splash jugable!
	posfade = -1440
	introind = 1
	alfafuera = 0
	move = false
	intro:play()
	timeac = 0.1
	velactual = 0.5
	limitxi = introvars[introind].limitxi
	limitxd = introvars[introind].limitxd
	inicializar()
	frames = 0
	player[1].stopin=0
	multvel = 1
	while true do
		controls.read()
		
		if introind < 3 then
			introimgs[introind].fnd:blit(0,0)
			screen.clip(0,introvars[introind].clipy,480,272)
			if frames == 10 and introind==1 then movef = true frames = 0 else movef = false end
			if introind==2 then movef = true end
			
			for i=1,5 do
				if movef then
					barras[i].y = barras[i].y - introvars[introind].mov*multvel
				end
				
				if player[1].y+introvars[introind].ballsize>barras[i].y and player[1].y<barras[i].y and player[1].x>barras[i].x-15 and player[1].x<barras[i].x+introvars[introind].barsize and player[1].stopin==0 then -- si player[1].cae en una barra
					player[1].stopin=i -- se detuvo en la barra i
					if barras[player[1].stopin].tipo==2 then -- pero si la barra tiene picos D:
						player[1].y=300 -- fuera de pantalla
						player[1].stopin=0
					end
				end
				
				if barras[i].y>272 and barras[i].y<=300 and player[1].y>=300 then -- donde ponerlo
					barras[i].tipo=1 -- la barra debera ser normal
					player[1].x=barras[i].x+(introvars[introind].barsize/2) -- justo en la barra
					player[1].y=barras[i].y-introvars[introind].ballsize
					player[1].stopin=i -- y esta detenido en esa barra
				end
				
				if player[1].stopin==i then
					player[1].y=barras[i].y-introvars[introind].ballsize
					if player[1].x<barras[i].x-15 or player[1].x>barras[i].x+introvars[introind].barsize-15 then
						player[1].stopin = 0
					end
					if player[1].y < introvars[introind].picos then
						player[1].y = 300
						player[1].stopin = 0
					end
				end
				
				if barras[i].y < introvars[introind].clipy-10 then
					barras[i].y = 380
					barras[i].x = math.random(limitxi,limitxd - introvars[introind].barsize)
				end
				
				if barras[i].tipo == 1 then
					introimgs[introind].bar1:blit(barras[i].x,barras[i].y)
				elseif barras[i].tipo == 2 then
					introimgs[introind].bar2:blit(barras[i].x,barras[i].y)
				end
			end
			
			if movef then
				if controls.right() then player[1].x = player[1].x + introvars[introind].mov*1.5*multvel
				elseif controls.left() then player[1].x = player[1].x - introvars[introind].mov*1.5*multvel end
				if player[1].stopin==0 then
					player[1].y = player[1].y + introvars[introind].mov*multvel
				end
			end
			
			player[1].x = math.min(math.max(player[1].x,40),440 - introvars[introind].ballsize) -- lmites de la pelota
			introimgs[introind].ball:blit(player[1].x,player[1].y)
			screen.clip()
			introimgs[introind].hud:blit(0,0)
			if introind==1 then
				frames = frames + 1
			end
		else
			blitworld()
			screen.print(96,255,"x 2")
			screen.print(300,255,"Score: 150")
		end
		
		if posfade==-480 then
			introind = introind + 1
			limitxi = introvars[introind].limitxi
			limitxd = introvars[introind].limitxd
			inicializar()
			movef=true
			frames=20
		end
		
		if move then
			posfade = posfade + 20
		end
		
		draw.gradrect(posfade,0,240,272,T,T,T,N)
		draw.gradrect(posfade+240,0,240,272,T,N,N,N)
		draw.fillrect(posfade+480,0,480,272,N)
		draw.gradrect(posfade+960,0,240,272,N,N,N,T)
		draw.gradrect(posfade+1200,0,240,272,N,T,T,T)
		
		if (intro:position()>5900 and intro:position()<6000) or (intro:position()>12000 and intro:position()<13000) then
			posfade = -1440
			move = true
		end
		
		if intro:position()>22000 then
			alfafuera = alfafuera + 2
			draw.fillrect(0,0,480,272,color.new(0,0,0,alfafuera))
			if alfafuera>=280 then break end
		end
		
		if intro:position()>12500 then multvel = multvel-0.015 end
		
		screen.flip()
	end
	intro:free()
	for i=1,2 do
		introimgs[i].fnd:free()
		introimgs[i].hud:free()
		introimgs[i].bar1:free()
		introimgs[i].bar2:free()
		introimgs[i].ball:free()
		introimgs[i] = nil
	end
	collectgarbage()
end

function blitworld()
	fonpos = fonpos + math.floor(1.5 + velactual)
	
	if fonpos>=315 then
		fonpos = 0
	end
	
	for k=1,balls do
		if player[k].x<=-40 or player[k].x>=400 then -- si est contra una pared, el fondo no debe moverse hacia los lados...
			fondes = 0
		end
	end
	
	fonosc = fonosc + fondes
	
	if fonosc>=132 or fonosc<=-132 then
		fonosc = 0
	end
	
	fnd:blit(-198+fonosc,fonpos-315)
	fnd:blit(198+fonosc,fonpos-315)
	fnd:blit(-198+fonosc,fonpos)
	fnd:blit(198+fonosc,fonpos)
	
	draw.gradrect(0,0,480,136,color.new(0,0,0,200),color.new(0,0,0,200),0x0,0x0)
	draw.gradrect(270,0,230,272,0x0,color.new(0,0,0,200),0x0,color.new(0,0,0,200))
	draw.gradrect(-20,0,230,272,color.new(0,0,0,200),0x0,color.new(0,0,0,200),0x0)
	fondo:position(0,0,-175)
	fondo:blit()
	if _3axis then
		fondo:position(0,0,-225)
		fondo:blit()
	end
	
	cora.ang = cora.ang - math.rad(5)
	heart:rotation(0,cora.ang,0)
	
	rojas=0
	
	for i=1,maxbars do
		if barras[i].tipo==2 then
			rojas=rojas+1
		end
	end
	
	for i=1,maxbars do
		barras[i].y=barras[i].y-1.5-velactual -- que suban las barras
		if barras[i].y<-10 then -- si se salen de pantalla
			if rojas>=maxreds then -- si hay cuatro o mas rojas en pantalla
				barras[i].x=math.random(10,350)
				barras[i].y=barras[i].maxy
				barras[i].tipo=1 -- alguna para poder pisar
			else -- sino
				barras[i].x=math.random(10,350)
				barras[i].y=barras[i].maxy
				barras[i].tipo=math.random(1,2) -- lo que venga
			end
			
			if math.floor(timeac-oldtimeac)==15 then -- happy time cada 15 segundos
				barras[i].tipo=3 -- un corazn
				oldtimeac=timeac -- para el prximo time
			end
		end
	end
	
	local players = {}
	players[1]={x=player[1].x,y=player[1].y,z=player[1].z}
	players[2]={x=player[2].x,y=player[2].y,z=player[2].z}
	
	
	fondes = 0
	if balls==1 then
		if controls.left() or controls.square() then
			player[1].x=player[1].x-4-velactual
			player[1].angz = player[1].angz - math.rad(8)
			fondes = 0.2+velactual
		elseif controls.right() or controls.circle() then
			player[1].x=player[1].x+4+velactual
			player[1].angz = player[1].angz + math.rad(8)
			fondes = -0.2-velactual
		end
		
		if _3axis then
			if controls.up() or controls.triangle() then
				player[1].z=player[1].z-4-velactual
				player[1].angx = player[1].angx + math.rad(8)
			elseif controls.down() or controls.cross() then
				player[1].z=player[1].z+4+velactual
				player[1].angx = player[1].angx - math.rad(8)	
			end
		end
	elseif balls==2 then
		if controls.left() then
			player[1].x=player[1].x-4-velactual
			fondes = 0.2+velactual
			player[1].angz = player[1].angz - math.rad(8)
		elseif controls.right() then
			player[1].x=player[1].x+4+velactual
			fondes = -0.2-velactual
			player[1].angz = player[1].angz + math.rad(8)
		end
		
		if controls.square() then
			player[2].x=player[2].x-4-velactual
			fondes = 0.2+velactual
			player[2].angz = player[2].angz - math.rad(8)
		elseif controls.circle() then
			player[2].x=player[2].x+4+velactual
			fondes = -0.2-velactual
			player[2].angz = player[2].angz + math.rad(8)
		end
		
		if _3axis then
			if controls.up() then
				player[1].z=player[1].z-4-velactual
				player[1].angx = player[1].angx + math.rad(8)
			elseif controls.down() then
				player[1].z=player[1].z+4+velactual
				player[1].angx = player[1].angx - math.rad(8)	
			end
			
			if controls.triangle() then
				player[2].z=player[2].z-4-velactual
				player[2].angx = player[2].angx + math.rad(8)
			elseif controls.cross() then
				player[2].z=player[2].z+4+velactual
				player[2].angx = player[2].angx - math.rad(8)	
			end
		end
	end
	
	if cogido==0 then -- tiene un corazon por cojer
		for k=1,balls do
			if player[k].x>cora.x-10 and player[k].x<cora.x+10 and player[k].stopin==cora.bar then -- si el jugador esta justo en la barra del corazon
				player[k].lives=player[k].lives+1 -- suma una vida
				barras[cora.bar].tipo=1 -- la barra pasa a ser normal
				cora.bar=0 -- ya no hay corazon en ninguna barra
				cogido=1 -- ya cogio el corazon
			end
		end
	end
	
	for k=1,balls do
		player[k].x = math.min(math.max(player[k].x,-40),400) -- lmite en X
		player[k].z = math.min(math.max(player[k].z,-285),-175) -- lmite en Z
	end
	
	for k=1,balls do
		if player[k].stopin~=0 then -- si et detenido en alguna barra
			if player[k].x<barras[player[k].stopin].x-70 or player[k].x>barras[player[k].stopin].x+70 or player[k].z<barras[player[k].stopin].z-32 or player[k].z>barras[player[k].stopin].z+32 then -- si se sale
				player[k].cae=1 -- se player[1].cae xD
				player[k].oldy=player[k].y -- para clculos de score supongo
				player[k].stopin=0 -- ya no est sobre ninguna barra
			end
		end
	end
	
	for k=1,balls do
		if player[k].cae==1 then -- si est cayendo
			player[k].y=player[k].y+1.5+velactual -- baja
		else -- sino
			player[k].y=player[k].y-1.5 -- sube...
		end
	end
	
	for k=1,balls do
		for i=1,maxbars do -- para todas las barras
			if player[k].y+20>barras[i].y and player[k].y<barras[i].y and player[k].x>barras[i].x-70 and player[k].x<barras[i].x+70 and player[k].z>barras[i].z-32 and player[k].z<barras[i].z+32 then -- si cae en una barra
				player[k].y=barras[i].y-21 -- va justo ahi, encima de la barra
				player[k].cae=0 -- ya no se cae :D
				player[k].stopin=i -- se detuvo en la barra i
				if barras[player[k].stopin].tipo==2 then -- pero si la barra tiene picos D:
					player[k].perdida=1 -- fuera vida
					player[k].y=400 -- fuera de pantalla
				end
				break -- ya no es necesario comprobar el resto...
			end
		end
	end
	
	for k=1,balls do
		if (player[k].y>400 and player[k].stopin==0) or player[k].y<10 then -- si se salio de pantalla o se ahostio contra los picos de arriba, y ya no est en una barra subiendo...
			player[k].perdida=1 -- pierde una vida...
			player[k].y=400 -- fuera de pantalla
		end
	end
	
	for k=1,balls do
		if player[k].perdida==1 then -- si est fuera de pantalla
			for i=1,maxbars do -- buscar una barra
				if barras[i].y>330 and barras[i].y<=430 and i~=player[3-k].stopin then -- donde ponerlo
					barras[i].tipo=1 -- la barra debera ser normal
					player[k].x=barras[i].x -- justo en la barra
					player[k].y=barras[i].y-21
					player[k].z=barras[i].z
					if plyrs==1 then
						player[1].lives=player[1].lives-1 -- y perdio una vida
					else
						player[k].lives=player[k].lives-1 -- y perdio una vida
					end
					player[k].cae=0 -- no ta cayendo, mas bien sube!
					player[k].stopin=i -- y esta detenido en esa barra
					player[k].perdida=0 -- a ver si pierde otra vida bwa ha ha ha
					break -- ya no es necesario buscar ms
				end
			end
		end
	end
	
	for i=1,maxbars do
		if barras[i].tipo==1 then
			bar1:position(barras[i].x-180,-barras[i].y+131,barras[i].z)
			bar1:blit()
		elseif barras[i].tipo==2 then
			bar2:position(barras[i].x-180,-barras[i].y+131,barras[i].z)
			bar2:blit()
		elseif barras[i].tipo==3 then
			bar1:position(barras[i].x-180,-barras[i].y+131,barras[i].z)
			bar1:blit()
			heart:position(barras[i].x-180,-barras[i].y+131+10,barras[i].z)
			heart:blit()
			cora.x=barras[i].x
			cora.bar=i
			cogido=0
		end
	end
	
	for k=1,balls do
		if player[k].cae==1 then
			player[k].suma=1
		else
			player[k].suma=0
		end
	end
	
	ball:rotation(-player[1].angx,0,-player[1].angz)
	ball:position(player[1].x-180,-player[1].y+131,player[1].z)
	ball:blit()
	
	if balls==2 then
		ball2:rotation(-player[2].angx,0,-player[2].angz)
		ball2:position(player[2].x-180,-player[2].y+131,player[2].z)
		ball2:blit()
	end
	
	banpos = banpos + 1
	if banpos > 500 then
		banpos = -530
	end
	
	banner:position(-238,banpos,banposz)
	banner:blit()
	
	heart:position(-57,-41,-61)
	heart:blit()
	
	if controls.press("select") then image.save("capture.png") end
end

function compantixetos(text,user)
	n=string.len(tostring(text))
	newstr={}
	newstr[1]=n
	md5=os.md5(tostring(text))

	a=1
	for i=3,(n*2)+2,2 do
		newstr[i]=string.sub(tostring(text),a,a)
		a=a+1
	end
	
	a=1
	for i=2,(n*2),2 do
		newstr[i]=string.sub(md5,a,a)
		a=a+1
	end

	for i=(n*2)+2,string.len(md5)+n+1 do
		newstr[i]=string.sub(md5,a,a)
		a=a+1
	end

	final=""

	for i=1,table.getn(newstr) do
		final=final..newstr[i]
	end
	
	local newstr=string.sub(os.md5(user),1,string.len(user))
	final=newstr..final
	final=final..string.sub(os.md5(user.."|"..final),1,5)
	
	return final
end

function descompantixetos(str,user)
	local real=0
	md5=string.sub(str,1,string.len(user))
	md52=string.sub(str,-5)
	str=string.sub(str,string.len(user)+1,-6)
	n=string.len(str)
	cant=tonumber(string.sub(str,1,1))
	result="Corrupted Data"
	
	if type(cant)=="number" then
		new=""
		for i=3,2+(cant*2),2 do
			new=new..string.sub(str,i,i)
		end
		
		result=new
		otrstr=""
		for i=2,(cant*2)+2,2 do
			otrstr=otrstr..string.sub(str,i,i)
		end
		
		otrstr=otrstr..string.sub(str,(cant*2)+3,n)
		if os.md5(new)~=otrstr then
			result="Corrupted Data"
		end
		
		if md5~=string.sub(os.md5(user),1,string.len(user)) then
			result="Corrupted Data"
		end
		
		newvar=os.md5(user.."|"..md5..str)
		if md52~=string.sub(newvar,1,5) then
			result="Corrupted Data"
		end
	end
	
	if type(tonumber(result))=="number" then
		real=tonumber(result)
	else
		real=0
	end
	
	return result,real
end

lastname="nombre"
nomuser=""
namescores = {"scores/2axis.txt","scores/3axis.txt","scores/extreme.txt","scores/2players.txt"}
scoretabl={}
for j=1,4 do -- 1: 2 axis, 2: 3 axis, 3: extreme, 4: 2 players
	scoretabl[j]={}
	for i=1,20 do
		scoretabl[j][i]={name="Anonymous",score="0",realscor=0}
	end
end

function ordenascor(tabl)
	local temp={}
	for i=1,table.getn(tabl)-1 do
		for j=i+1,table.getn(tabl) do
			if (tabl[i].realscor<tabl[j].realscor) then
				temp=tabl[i]
				tabl[i]=tabl[j]
				tabl[j]=temp
			end
		end
	end
	return tabl
end

function loadscores()
	for k=1,4 do
		index = 1
		if files.exists(namescores[k]) then
			for leido in io.lines(namescores[k],"r") do
				if leido~="" then
					a=string.find(leido,"|")
					scoretabl[k][index].name=string.sub(leido,1,a-1)
					scoretabl[k][index].score, scoretabl[k][index].realscor = descompantixetos(string.sub(leido,a+1), scoretabl[k][index].name)
					index=index+1
				end
			end
			ordenascor(scoretabl[k])
		end
	end
end

function savescores(num)
	k = num
	file=io.open(namescores[k],"w")
	file:write(scoretabl[k][1].name.."|"..compantixetos(scoretabl[k][1].realscor,scoretabl[k][1].name))
	for i=2,20 do
		file:write("\n"..scoretabl[k][i].name.."|"..compantixetos(scoretabl[k][i].realscor,scoretabl[k][i].name))
	end
	file:flush()
	file:close()
end

xa=0
xb=0
function drawfog(al)
	if not al then
		al=100
	end
	image.fxadd(xb,0,fog_b,al)
	image.fxadd(xb-480,0,fog_b,al)
	image.fxadd(xa,0,fog_a,al)
	image.fxadd(xa-480,0,fog_a,al)
	
	xa=xa+2
	xb=xb+1
	
	if xa>480 then
		xa=0
	end
	if xb>480 then
		xb=0
	end
end

angsc = 0
function blitscores()
	drawfog()
	angsc = angsc - 1
	scores_title:position(-15,80,-165)
	scores_title:blit()
	ball:rotation(0,angsc,0)
	ball:position(-15,79,-165)
	ball:blit()
	local tmpscoretabl = {}
	if plyrs==1 and balls==2 then
		tmpscoretabl = scoretabl[3]
	elseif plyrs==2 then
		tmpscoretabl = scoretabl[4]
	else
		if _3axis then
			tmpscoretabl = scoretabl[2]
		else
			tmpscoretabl = scoretabl[1]
		end
	end
	
	screen.clip(0,89,480,272)
	for i = 1, 20 do 
		color1=color.new(255,255,255)
		
		if i<10 then screen.print(10,105 + (20*(i-1)) - SY,"    ".."0"..i..".  "..tmpscoretabl[i].name,0.8,color1,negro)
		elseif i>=10 then screen.print(10,105 + (20*(i-1)) - SY,"    "..i..".  "..tmpscoretabl[i].name,0.8,color1,negro) end

		if tmpscoretabl[i].score=="Corrupted Data" then
			screen.print(310,105 + (20*(i-1)) - SY,"Corrupted Data",0.8,color1,negro)
		elseif tmpscoretabl[i].score~="Corrupted Data" then
			if tonumber(tmpscoretabl[i].score)>=1000 then screen.print(410,105 + (20*(i-1)) - SY,tmpscoretabl[i].score,0.8,color1,negro)
			elseif tonumber(tmpscoretabl[i].score)<1000 and tonumber(tmpscoretabl[i].score)>=100 then screen.print(410,105 + (20*(i-1)) - SY,"0"..tmpscoretabl[i].score,0.8,color1,negro)
			elseif tonumber(tmpscoretabl[i].score)<100 and tonumber(tmpscoretabl[i].score)>=10 then screen.print(410,105 + (20*(i-1)) - SY,"00"..tmpscoretabl[i].score,0.8,color1,negro)
			elseif tonumber(tmpscoretabl[i].score)<10 and tonumber(tmpscoretabl[i].score)>=0 then screen.print(410,105 + (20*(i-1)) - SY,"000"..tmpscoretabl[i].score,0.8,color1,negro)
			elseif tonumber(tmpscoretabl[i].score)==0 then screen.print(410,105 + (20*(i-1)) - SY,"0000",0.8,color1,negro)
			else screen.print(410,105 + (20*(i-1)) - SY,tmpscoretabl[i].score,0.8,color1,negro) end
		end
	end
	
	if SY>10 then au:blit(3,90) end
	if SY<230 then ad:blit(3,249) end
	
	if (500 - SY)>272 then
		if controls.down() then
			SY = math.min(SY + 5,320)
		end
	end

	if controls.up() then
		SY = math.max(SY - 5,10)
	end
	screen.clip()
	
	if al>0 then
		al = al + alsum
		draw.fillrect(0,0,480,272,color.new(0,0,0,al))
	end
end

function scores()
	SY = 10
	al = 255
	alsum = -4
	
	while true do
		if menusnd:percent() >= 99.8 then
			menusnd:percent(6.95)
		end
		
		controls.read()
		blitscores()
		
		--if controls.press("triangle") then lightstation(blitscores) end
		
		if alsum == 4 and al>=255 then
			break
		end
		
		if controls.circle() and alsum==-4 and al<=0 then al = 2 alsum = 4 end
		
		screen.flip()
	end
end

barras = {}
function inicializar()
	acel=15 -- aceleracin
	oldtimeac=0 -- si ha pasado X tiempo, dar una barra con corazn
	cogido=0 -- ha cogido un corazn?
	fin=0 -- se qued sin vidas?
	
	barras[0]={x=-80,y=-20,tipo=0}
	barras[1]={x=math.random(limitxi,limitxd),y=30,maxy=380,z=-198,tipo=math.random(1,2)}
	barras[2]={x=math.random(limitxi,limitxd),y=100,maxy=380,z=-198,tipo=math.random(1,2)}
	barras[3]={x=math.random(limitxi,limitxd),y=170,maxy=380,z=-198,tipo=math.random(1,2)}
	barras[4]={x=math.random(limitxi,limitxd),y=240,maxy=380,z=-198,tipo=1}
	barras[5]={x=math.random(limitxi,limitxd),y=310,maxy=380,z=-198,tipo=math.random(1,2)}
	
	barras[6]={x=math.random(limitxi,limitxd),y=60,maxy=410,z=-260,tipo=math.random(1,2)}
	barras[7]={x=math.random(limitxi,limitxd),y=130,maxy=410,z=-260,tipo=math.random(1,2)}
	barras[8]={x=math.random(limitxi,limitxd),y=200,maxy=410,z=-260,tipo=math.random(1,2)}
	barras[9]={x=math.random(limitxi,limitxd),y=270,maxy=410,z=-260,tipo=1}
	barras[10]={x=math.random(limitxi,limitxd),y=340,maxy=410,z=-260,tipo=math.random(1,2)}
	
	player={}
	player[1]={x=barras[4].x,y=barras[4].y-21,z=barras[4].z,lives=totliv,angz=0,angx=0}
	player[2]={x=barras[9].x,y=barras[9].y-21,z=barras[9].z,lives=totliv,angz=0,angx=0}
	player[1].perdida=0 -- pierde una vida
	player[1].stopin=4 -- barra en la que est el jugador
	player[1].cae=0
	player[2].perdida=0 -- pierde una vida
	player[2].stopin=4 -- barra en la que est el jugador
	player[2].cae=0
	rojas=0 -- cantidad de barras rojas en pantalla
	tiempo=timer.new(10) -- tiempo que ha pasado, para calcular velocidad y eso
	player[1].score=0
	player[2].score=0
	player[1].suma=0
	player[2].suma=0
	player[1].oldy=0
	player[2].oldy=0
	cora={x=0,bar=0,ang=0}
	banpos = -430
	fonpos = 0
	fonosc = 0
	fondes = 0
end

name=""
function chimeosk(title,borrar)
	
	if borrar then
		name = ""
	end
	
	tecladomin={}
	tecladomay={}
	tecladosim={}
	teclado123={}

	tecladomin[1]={"q","w","e","r","t","y","u","i","o","p"}
	tecladomin[2]={"a","s","d","f","g","h","j","k","l","<-"}
	tecladomin[3]={"z","x","c","v","b","n","m"," ","$im","MAY"}

	tecladomay[1]={"Q","W","E","R","T","Y","U","I","O","P"}
	tecladomay[2]={"A","S","D","F","G","H","J","K","L","<-"}
	tecladomay[3]={"Z","X","C","V","B","N","M"," ","$im","min"}

	tecladosim[1]={"!","#","$","%","&","'",'"',"[","]","~"}
	tecladosim[2]={"=","{","}","`","<",">","-","_","+","<-"}
	tecladosim[3]={"*","?","(",")","^","/"," ","123","min","MAY"}

	teclado123[1]={"0","1","2","3","4","5","6","7","8","9"}
	teclado123[2]={"=","{","}","`","<",">","-","_","+","<-"}
	teclado123[3]={"*","?","(",")","^","/"," ","$im","min","MAY"}

	tecladoact=tecladomin
	cur={x=1,y=1}
	colbot1=color.new(255,255,255)
	colbot2=color.new(50,80,255)
	
	while true do
		controls.read()
		
		if gamesnd:percent() >= 94.55 then
			gamesnd:percent(0.045)
		end
		
		fndimg:blit(0,0)
		draw.fillrect(0,0,480,272,color.new(0,0,0,200))
		
		enter=""
		if controls.press("up") then cur.y=cur.y-1 end
		if controls.press("down") then cur.y=cur.y+1 end
		if controls.press("right") then cur.x=cur.x+1 end
		if controls.press("left") then cur.x=cur.x-1 end
		
		if cur.y<1 then cur.y=3
		elseif cur.y>3 then cur.y=1 end
		
		if cur.x<1 then cur.x=10
		elseif cur.x>10 then cur.x=1 end
		
		for j=0,2 do
			for i=0,9 do
				if cur.x==i+1 and cur.y==j+1 then
					colbot2=color.new(205,175,0)
				else
					colbot2=color.new(50,80,255)
				end
				
				pos=(23+(i*48))-(screen.textwidth(tecladoact[j+1][i+1],0.9)/2)
				
				if controls.press("cross") and colbot2==color.new(205,175,0) then
					draw.gradrect(5+(i*48),138+(j*50),40,20,colbot1,colbot1,color.new(165,125,0),color.new(165,125,0))
					if tecladoact[j+1][i+1]=="_" then
						screen.print(pos+2,142+(j*50),tecladoact[j+1][i+1],0.9,color.new(245,245,245),0x0)
					else
						screen.print(pos+2,145+(j*50),tecladoact[j+1][i+1],0.9,color.new(245,245,245),0x0)
					end
					enter=tecladoact[j+1][i+1]
				else
					draw.fillrect(3+(i*48)+2,138+(j*50),40,20,color.new(0,0,0,250))
					draw.gradrect(3+(i*48),136+(j*50),40,20,colbot1,colbot1,colbot2,colbot2)
					if tecladoact[j+1][i+1]=="_" then
						screen.print(pos,140+(j*50),tecladoact[j+1][i+1],0.9,color.new(245,245,245),0x0)
					else
						screen.print(pos,143+(j*50),tecladoact[j+1][i+1],0.9,color.new(245,245,245),0x0)
					end
				end
			end
		end

		if enter=="MAY" then
			tecladoact=tecladomay
		elseif enter=="min" then
			tecladoact=tecladomin
		elseif enter=="$im" then
			tecladoact=tecladosim
		elseif enter=="123" then
			tecladoact=teclado123
		elseif enter=="<-" then
			if string.len(name)>0 then name=string.sub(name,1,-2) end
		end

		if string.len(name)<15 then
			if enter~="MAY" and enter~="min" and enter~="$im" and enter~="<-" and enter~="123" then
				name=name..enter
			end
		end
		
		screen.print(20,20,title,0.8,color.new(255,255,255),0x0)
		screen.print(20,40,"Enter your name:                                                    "..string.len(name).."/15",0.8,color.new(255,255,255),0x0)
		screen.print(20,70,name,0.9,color.new(255,255,255),0x0)
		
		if string.len(name)>2 then
			screen.print(20,100,"Press Start to finish",0.8,color.new(255,255,255),0x0)
			if controls.press("start") then
				break
			end
		end
		
		screen.flip()
		if controls.press("cross") then
			screen.waitvblankstart(8)
		end
	end
	return name
end

function game()
	otim = timer.new()
	otim:start()
	otimac = 0
	alfapres = 200
	banpos = banpos - 1 -- viene con un 1 de mas del menu xD
	while otimac<4 do
		otimac = math.floor(otim:time()/1000)
		
		if gamesnd:percent() >= 94.55 then
			gamesnd:percent(0.045)
		end
		
		fnd:blit(-198+fonosc,fonpos-315)
		fnd:blit(198+fonosc,fonpos-315)
		fnd:blit(-198+fonosc,fonpos)
		fnd:blit(198+fonosc,fonpos)
		
		draw.gradrect(0,0,480,136,color.new(0,0,0,200),color.new(0,0,0,200),0x0,0x0)
		draw.gradrect(270,0,230,272,0x0,color.new(0,0,0,200),0x0,color.new(0,0,0,200))
		draw.gradrect(-20,0,230,272,color.new(0,0,0,200),0x0,color.new(0,0,0,200),0x0)
		fondo:position(0,0,-175)
		fondo:blit()
		if _3axis then
			fondo:position(0,0,-225)
			fondo:blit()
		end
		
		for i=1,maxbars do
			if barras[i].tipo==1 then
				bar1:position(barras[i].x-180,-barras[i].y+131,barras[i].z)
				bar1:blit()
			elseif barras[i].tipo==2 then
				bar2:position(barras[i].x-180,-barras[i].y+131,barras[i].z)
				bar2:blit()
			end
		end
		
		ball:rotation(-player[1].angx,0,-player[1].angz)
		ball:position(player[1].x-180,-player[1].y+131,player[1].z)
		ball:blit()
		
		if balls==2 then
			ball2:rotation(-player[2].angx,0,-player[2].angz)
			ball2:position(player[2].x-180,-player[2].y+131,player[2].z)
			ball2:blit()
		end
		
		banpos = banpos + 1
		if banpos > 500 then
			banpos = -530
		end
		
		banner:position(-238,banpos,banposz)
		banner:blit()
		
		cora.ang = cora.ang - math.rad(5)
		heart:rotation(0,cora.ang,0)
		heart:position(-57,-41,-61)
		heart:blit()
		
		if plyrs==1 then
			screen.print(96,255,"x "..player[1].lives)
			screen.print(300,255,"Score: "..math.floor(player[1].score))
		else
			heart:position(8,-41,-61)
			heart:blit()
			screen.print(96,255,"x "..player[1].lives.."    Score: "..math.floor(player[1].score))
			screen.print(280,255,"x "..player[2].lives.."    Score: "..math.floor(player[2].score))
		end
		
		draw.fillrect(0,0,480,272,color.new(0,0,0,alfapres))
		
		if otimac<=2 then
			screen.print(225,145,3-otimac,2,color.new(255,255,255),N)
		else
			screen.print(202,145,"Go!",2,color.new(255,255,255),N)
			alfapres = alfapres - 4
		end
		screen.flip()
	end
	
	player[1].cae = 1 -- al inicio, la bola va cayendo
	player[2].cae = 1 -- al inicio, la bola va cayendo
	tiempo:reset()
	tiempo:start()
	entraaltop = false
	salidam = false
	while true do
		controls.read()
		
		if gamesnd:percent() >= 94.55 then
			gamesnd:percent(0.045)
		end
		
		timeac=tiempo:time()/1000
		velactual=timeac/10 * acel/100
		
		for k=1,balls do
			if player[k].suma==1 then
				if player[k].y<272 then
					if plyrs == 2 then
						player[k].score=player[k].score+((player[k].y-player[k].oldy)/500)+velactual
					else
						player[1].score=player[1].score+((player[k].y-player[k].oldy)/500)+velactual
					end
				end
			end
		end
		
		blitworld()
		
		--if controls.press("triangle") then lightstation(blitworld) end
		
		if plyrs==1 then
			if player[1].lives<0 then
				if balls==1 and _3axis then cond = math.floor(player[1].score)>scoretabl[2][20].realscor
				elseif balls==1 then cond = math.floor(player[1].score)>scoretabl[1][20].realscor
				else cond = math.floor(player[1].score)>scoretabl[3][20].realscor end
				if cond then
					entraaltop = true
					title = "You have reached the top 20!"
				end
				break
			end
		else
			if player[1].lives<0 then
				if math.floor(player[2].score)>scoretabl[4][20].realscor then
					title = "Blue ball, you have reached the top 20!"
					title2 = "Red ball, enter your name..."
					entraaltop = true
				end
				break
			elseif player[2].lives<0 then
				if math.floor(player[1].score)>scoretabl[4][20].realscor then
					title = "Red ball, you have reached the top 20!"
					title2 = "Blue ball, enter your name..."
					entraaltop = true
				end
				break
			end
		end
		
		if plyrs==1 then
			screen.print(96,255,"x "..player[1].lives)
			screen.print(300,255,"Score: "..math.floor(player[1].score))
		else
			heart:position(8,-41,-61)
			heart:blit()
			screen.print(96,255,"x "..player[1].lives.."    Score: "..math.floor(player[1].score))
			screen.print(280,255,"x "..player[2].lives.."    Score: "..math.floor(player[2].score))
		end
		
		screen.flip()
		
		if controls.press("start") then
			tiempo:stop()
			tmpimg = screen.toimage()
			screen.waitvblankstart(5)
			
			local txt = {"Resume", "Music: "..(soundon and "On" or "Off"), "Go to menu"}
			local op = 1
			local alfamp = 255
			local alfamps = -4
			
			for i=0,128,5 do
				if gamesnd:percent() >= 94.55 then
					gamesnd:percent(0.045)
				end
				tmpimg:blit(0,0)
				draw.fillrect(0,0,480,272,color.new(0,0,0,i))
				image.blend(128,10,paused,i*2)
				
				for o=1,3 do
					if o == op then
						screen.print(240-screen.textwidth(txt[o],1.5)/2,115+(o-1)*50,txt[o],1.5,color.new(255,255,255,i*2),color.new(0,50,200,i*2))
					else
						screen.print(240-screen.textwidth(txt[o],1.5)/2,115+(o-1)*50,txt[o],1.5,color.new(255,255,255,i*2),0x0)
					end
				end
				
				screen.flip()
			end
			
			while true do
				controls.read()
				if gamesnd:percent() >= 94.55 then
					gamesnd:percent(0.045)
				end
				tmpimg:blit(0,0)
				draw.fillrect(0,0,480,272,color.new(0,0,0,128))
				image.blend(128,10,paused,255)
				
				alfamp = alfamp + alfamps
				if alfamp <= 0 then
					alfamps = 4
				elseif alfamp >= 255 then
					alfamps = -4
				end
				
				for o=1,3 do
					if o == op then
						screen.print(240-screen.textwidth(txt[o],1.5)/2,115+(o-1)*50,txt[o],1.5,color.new(255,255,255),color.new(0,50,200,alfamp))
					else
						screen.print(240-screen.textwidth(txt[o],1.5)/2,115+(o-1)*50,txt[o],1.5,color.new(255,255,255),0x0)
					end
				end
				
				if controls.press("up") then op = op - 1 if op < 1 then op = 3 end alfamp = 255 end
				if controls.press("down") then op = op + 1 if op > 3 then op = 1 end alfamp = 255 end
				
				if controls.press("cross") then
					if op==1 then
						break
					elseif op==2 then
						soundon = not soundon
						txt[2] = "Music: "..(soundon and "On" or "Off")
						if soundon then gamesnd:volume(199) end
						gamesnd:pause(-1)
						menu:setframe(3,3-menu:currentframe(3))
					elseif op==3 then
						salidam = true
						break
					end
				end
				
				if controls.press("start") then break end
				
				screen.flip()
			end

			tmpimg2 = screen.toimage()
			screen.waitvblankstart(5)
			
			for i=128,0,-5 do
				if gamesnd:percent() >= 94.55 then
					gamesnd:percent(0.045)
				end
				tmpimg:blit(0,0)
				draw.fillrect(0,0,480,272,color.new(0,0,0,i))
				image.blend(0,0,tmpimg2,i*2)
				screen.flip()
			end
			tiempo:start()
			tmpimg:free()
			tmpimg2:free()
		end
		if salidam then entraaltop=false break end
	end
	
	fndimg = screen.toimage()
	screen.waitvblankstart(5)
	
	for i=1,200,4 do
		fndimg:blit(0,0)
		draw.fillrect(0,0,480,272,color.new(0,0,0,i))
		screen.flip()
	end
	
	if entraaltop then
		if plyrs == 1 then
			score = math.floor(player[1].score)
			name = chimeosk(title)
			screen.waitvblankstart(10)
			if balls==1 and _3axis then
				table.insert(scoretabl[2],{name = name, score = tostring(score), realscor = score})
				ordenascor(scoretabl[2])
				savescores(2)
			elseif balls==2 then
				table.insert(scoretabl[3],{name = name, score = tostring(score), realscor = score})
				ordenascor(scoretabl[3])
				savescores(3)
			else
				table.insert(scoretabl[1],{name = name, score = tostring(score), realscor = score})
				ordenascor(scoretabl[1])
				savescores(1)
			end
		else
			if player[1].lives >= 0 then
				score = math.floor(player[1].score)
			else
				score = math.floor(player[2].score)
			end
			name = chimeosk(title).." (vs "..chimeosk(title2,true)..")"
			screen.waitvblankstart(10)
			table.insert(scoretabl[4],{name = name, score = tostring(score), realscor = score})
			ordenascor(scoretabl[4])
			savescores(4)
		end
		screen.waitvblankstart(5)
	end
	
	for i=200,255,4 do
		fndimg:blit(0,0)
		draw.fillrect(0,0,480,272,color.new(0,0,0,i))
		screen.flip()
	end
	fndimg:free()
end

function menufunc()
	al = 2
	alsum = 4
	showscores = false
	showgame = false
	showcredits = false
	axisc = false
	axisca = 0
	axiscd = 5
	
	ringw = 320
	ringh = 60
	ringa = 0
	ringasum = 5
	
	flrctl = 200
	flrcta = 255
	flrctd = -1
	
	inicializar()
	tiempo:stop()
	valact = 0.8
	peract = 94.65
	setgmv = false
	setgmva = 0
	setgmvd = 5
	gmv = {}
	salintro = true
	soundon = true -- sonidos on!
	gamemode = 1 -- modo de juego, 1: normal (1 bola, 2 o 3 axis), 2: extreme (2 bolas, 3 axis), 3: 2 players (2 bolas, 3 axis)
	while true do
		controls.read()
		
		if menusnd:percent() >= 99.8 then
			menusnd:percent(6.95)
		end
		
		if gamesnd:percent() >= 94.55 then
			gamesnd:percent(0.045)
		end
		
		fnd:blit(-198+fonosc,fonpos-315)
		fnd:blit(198+fonosc,fonpos-315)
		fnd:blit(-198+fonosc,fonpos)
		fnd:blit(198+fonosc,fonpos)
		
		draw.gradrect(0,0,480,136,color.new(0,0,0,200),color.new(0,0,0,200),0x0,0x0)
		draw.gradrect(270,0,230,272,0x0,color.new(0,0,0,200),0x0,color.new(0,0,0,200))
		draw.gradrect(-20,0,230,272,color.new(0,0,0,200),0x0,color.new(0,0,0,200),0x0)
		fondo:position(0,0,-175)
		fondo:blit()
		if _3axis then
			fondo:position(0,0,-225)
			fondo:blit()
		end
		
		for i=1,maxbars do
			if barras[i].tipo==1 then
				bar1:position(barras[i].x-180,-barras[i].y+131,barras[i].z)
				bar1:blit()
			elseif barras[i].tipo==2 then
				bar2:position(barras[i].x-180,-barras[i].y+131,barras[i].z)
				bar2:blit()
			end
		end
		
		ball:rotation(-player[1].angx,0,-player[1].angz)
		ball:position(player[1].x-180,-player[1].y+131,player[1].z)
		ball:blit()
		
		if balls==2 then
			ball2:rotation(-player[2].angx,0,-player[2].angz)
			ball2:position(player[2].x-180,-player[2].y+131,player[2].z)
			ball2:blit()
		end
		
		banpos = banpos + 1
		if banpos > 500 then
			banpos = -530
		end
		
		banner:position(-238,banpos,banposz)
		banner:blit()
		
		cora.ang = cora.ang - math.rad(5)
		heart:rotation(0,cora.ang,0)
		heart:position(-57,-41,-61)
		heart:blit()
		
		if plyrs==1 then
			screen.print(96,255,"x "..player[1].lives)
			screen.print(300,255,"Score: "..math.floor(player[1].score))
		else
			heart:position(8,-41,-61)
			heart:blit()
			screen.print(96,255,"x "..player[1].lives.."    Score: "..math.floor(player[1].score))
			screen.print(280,255,"x "..player[2].lives.."    Score: "..math.floor(player[2].score))
		end
		
		if salintro then
			ringa = ringa + ringasum
			if ringa >= 255 then
				ringa = 255
				ringasum = -5
				flrcta = 200
				flrctd = 0
				salintro = false
			end
		end
		
		flrcta = flrcta + flrctd
		if flrcta < flrctl then flrcta = flrctl end
		
		draw.fillrect(0,0,480,272,color.new(0,0,0,flrcta))
		
		menu:resize(ringw,ringh)
		menu:setalfa(ringa)
		op = menu:blit()
		
		if controls.press("cross") then
			if op==1 and ringasum==-5 and (not axisc) and (not setgmv) then if soundon then gamesnd:play(2) end showgame = true end
			if op==2 and alsum==4 and al==2 and (not showscores) and (not axisc) and (not setgmv) then showscores = true end
			if op==3 then menu:setframe(3,3-menu:currentframe(3)) menusnd:pause(-1) soundon = not soundon end -- music on/off
			if op==4 and (not axisc) and (not setgmv) and balls==1 then axisc = true end -- solo se puede cambiar si esta en 1 bola, las otras, NO, pq obligatoriamente tienen q ser 3 axis
			if op==5 and alsum==4 and al==2 and (not showcredits) and (not axisc) and (not setgmv) then showcredits = true end
			if op==6 and (not axisc) and (not setgmv) then
				if gamemode<3 then gamemode = gamemode + 1 else gamemode = 1 end
				setgmv = true
			end
			if op==7 and (not axisc) and (not setgmv) then
				tmpimg = screen.toimage()
				screen.waitvblankstart(5)
				for i=255,0,-5 do
					if soundon then menusnd:volume(math.min(math.max(i,0),199)) end
					image.blend(0,0,tmpimg,i)
					screen.flip()
				end
				fondo:free()
				banner:free()
				bar1:free()
				bar2:free()
				ball:free()
				heart:free()
				scores_title:free()
				screen.waitvblankstart(5)
				os.quit()
			end 
			if op==8 and (not axisc) and (not setgmv) then
				menu:setframe(8,3-menu:currentframe(8)) -- analog on/off
				if menu:currentframe(8) == 1 then
					controls.analogtodigital(0)
				else
					controls.analogtodigital(80)
				end
			end
		end
		
		if soundon and not salintro then
			menusnd:volume(math.min(math.max(ringa,0),199))
			gamesnd:volume(199 - math.min(math.max(ringa,0),199))
		end
		
		if setgmv then
			setgmva = setgmva + setgmvd
			draw.fillrect(0,0,480,272,color.new(0,0,0,setgmva))
			if setgmva >= 255 then
				setgmvd = -5
				menu:setframe(6,gamemode)
				if gamemode==1 then
					plyrs=1
					balls=1
				elseif gamemode==2 then
					plyrs=1
					balls=2
					_3axis=true
					menu:setframe(4,2)
					maxbars = 10
					maxreds = 4
					banposz = -220
					menu:setframe(8,1)
					controls.analogtodigital(0)
				elseif gamemode==3 then
					plyrs=2
					balls=2
					_3axis=true
					menu:setframe(4,2)
					maxbars = 10
					maxreds = 4
					banposz = -220
					menu:setframe(8,1)
					controls.analogtodigital(0)
				end
			elseif setgmva <= 0 and setgmvd == - 5 then
				setgmva = 0
				setgmv = false
				setgmvd = 5
			end
		end
		
		if axisc then
			axisca = axisca + axiscd
			draw.fillrect(0,0,480,272,color.new(0,0,0,axisca))
			if axisca >= 255 then
				axiscd = -5
				menu:setframe(4,3-menu:currentframe(4))
				_3axis = not _3axis
				maxbars = 15 - maxbars
				maxreds = 6 - maxreds
				banposz = -418 - banposz
			elseif axisca <= 0 and axiscd == - 5 then
				axisca = 0
				axisc = false
				axiscd = 5
			end
		end
		
		if showgame then
			ringw = ringw - ringasum*2
			ringh = ringh - ringasum*2
			ringa = ringa + ringasum

			if ringa < 0 then
				if soundon then
					menusnd:pause()
				end
				game()
				if soundon then
					menusnd:play(1)
				end
				inicializar()
				ringa = 2
				ringasum = 5
				flrcta = 255
				flrctd = -2
				flrctl = 200
			elseif ringa>=255 then
				if soundon then
					gamesnd:pause()
				end
				ringa = 255
				ringasum = -5
				showgame = false
				ringw = 320
				ringh = 60
			end
		end
		
		if showscores or showcredits then
			al = al + alsum
			draw.fillrect(0,0,480,272,color.new(0,0,0,al))
			if al>=255 then
				if showscores then scores() else creditos() end
				alsum = -4
			end
			if alsum==-4 and al<=0 then
				alsum=4
				al=2
				showscores = false
				showcredits = false
			end
		end
		
		screen.flip()
	end
end

loadscores()
os.luasplash()
os.luadevsplash()
genesissplash()
screen.waitvblankstart(80)
splash()
menusnd:play(1)
gamesnd:volume(0)
menufunc()